Skip to main content
Available in🇮🇳 India
You can now create an order along with a payment using a single API for netbanking, cards and UPI. Given below are details and examples for all three payment methods followed by steps to integrate S2S JSON API and accept payments using netbanking, cards and UPI.
Create an order along with payment using the consolidated order and payment API. This single API call combines order and payment creation, resulting in a more efficient and faster transaction process.Create a order along with payment by:
  • Making a single API call to Razorpay, combining order and payment creation.
  • Authenticating using the provided credentials, ensuring access to the consolidated payment API.
  • Manually integrating the API sample codes on your server.
Use the following API to create an order along with payment using netbanking as the payment method:

Request Parameters

integer
required
The amount for which the order was created in currency subunits. For example, for an amount of ₹295.00, enter 29500. The same amount will be used for the payment creation. For the partial payment scenario, we will use the amount specified in the payment request object in case.
string
required
The currency in which the transaction should be made. See the list of supported currencies. Length must be of 3 characters.
string
Receipt number that corresponds to this order. Can have a maximum length of 40 characters and has to be unique.
boolean
Indicates whether the customer can make a partial payment. Possible values:
  • true: The customer can make partial payments.
  • false (default): The customer cannot make partial payments.
integer
Minimum amount that must be paid by the customer as the first partial payment. For example, if an amount of ₹7,000 is to be received from the customer in two installments of #1 - ₹5,000, #2 - ₹2,000, then you can set this value as 500000. This parameter should be passed only if partial_payment is true.
string
Unique identifier of the customer.
object
Details regarding the transfer.
string
The recipient account ID for fund transfer.
string
The amount of the transfer.
string
required
The currency in which the transaction should be made. See the list of supported currencies. Length must be of 3 characters.
object
Key-value pair that can be used to store additional information about the entity. Maximum 15 key-value pairs, 256 characters (maximum) each. For example, "note_key": "Beam me up Scotty".
string
Notes associated with the linked account.
boolean
required
Indicates whether the account settlement for transfer is on hold. Possible values:
  • true: Puts the settlement on hold.
  • false: Releases the settlement.
integer
required
Timestamp until which the transfer amount is on hold.
object
Details of the bank account that the customer provides at the time of registration.
string
Account number of the customers bank account.
string
The name associated with the bank account.
string
The IFSC code of the bank.
array
Payment capture settings for the payment. The options sent here override the account level auto-capture settings configured using the Dashboard.
string
required
Option to automatically capture payment. Possible values:
  • automatic: Payments are auto-captured according to the configurations specified in the capture_options array.
  • manual: You have to manually capture payments using our Capture API or from the Dashboard.
array
Use this array to determine the expiry period for automatic and manual capture of payments and the refund speed in the case of non-capture.
integer
Time in minutes till when payments in the authorized state should be auto-captured. Minimum value 12 minutes. This parameter is mandatory only if the value of capture parameter is automatic.
integer
Time in minutes till when you can manually capture payments in the authorized state.
  • Must be equal to or greater than the automatic_expiry_period value.
  • Default value 7200 minutes.
  • Maximum value 7200 minutes.
  • Payments in the authorized state after the manual_expiry_period are auto-refunded.
string
required
Refund speed for payments that were not captured (automatically or manually). Possible values:
  • optimum: We try to process the refund instantly. We charge a small fee for this. If it is not possible to process an instant refund, we will process a normal refund in 5-7 working days. Learn more about instant refunds.
  • normal: The refund is processed in 5-7 working days.

    If no value is passed, the refund is processed using the default speed set on the Dashboard.
object
required
Details of the payment.
integer
The amount for which the order was created in currency subunits. For example, for an amount of ₹295.00, enter 29500. The same amount will be used for the payment creation. For the partial payment scenario, we will use the amount specified in the payment request object in case.
string
required
Email address of the customer.
integer
required
Contact number of the customer.
string
required
The customer’s IP address.
string
required
Name of the payment method (example, netbanking, cards and upi).
string
required
Name of the bank.
string
required
Description of the payment.Descriptions for the response parameters are present in the Response parameter table.
Watch Out!The request body will differ from those created by other PSPs for tokens created on Razorpay.
The following API will create a payment with cards as the payment method:

Request Parameters

integer
required
The amount for which the order was created in currency subunits. For example, for an amount of ₹295.00, enter 29500. The same amount will be used for the payment creation. For the partial payment scenario, we will use the amount specified in the payment request object in case.
string
required
The currency in which the transaction should be made. See the list of supported currencies. Length must be of 3 characters.
string
Receipt number that corresponds to this order. Can have a maximum length of 40 characters and has to be unique.
boolean
Indicates whether the customer can make a partial payment. Possible values:
  • true: The customer can make partial payments.
  • false (default): The customer cannot make partial payments.
integer
Minimum amount that must be paid by the customer as the first partial payment. For example, if an amount of ₹7,000 is to be received from the customer in two installments of #1 - ₹5,000, #2 - ₹2,000, then you can set this value as 500000. This parameter should be passed only if partial_payment is true.
string
Unique identifier of the customer.
object
Details regarding the transfer.
string
The recipient account ID for fund transfer.
string
The amount of the transfer.
string
required
The currency in which the transaction should be made. See the list of supported currencies. Length must be of 3 characters.
object
Key-value pair that can be used to store additional information about the entity. Maximum 15 key-value pairs, 256 characters (maximum) each. For example, "note_key": "Beam me up Scotty".
string
Notes associated with the linked account.
boolean
required
Indicates whether the account settlement for transfer is on hold. Possible values:
  • true: Puts the settlement on hold.
  • false: Releases the settlement.
string
required
Timestamp until which the transfer amount is on hold.
array
Payment capture settings for the payment. The options sent here override the account level auto-capture settings configured using the Dashboard.
string
required
Option to automatically capture payment. Possible values:
  • automatic: Payments are auto-captured according to the configurations specified in the capture_options array.
  • manual: You have to manually capture payments using our Capture API or from the Dashboard.
array
Use this array to determine the expiry period for automatic and manual capture of payments and the refund speed in the case of non-capture.
integer
Time in minutes till when payments in the authorized state should be auto-captured. Minimum value 12 minutes. This parameter is mandatory only if the value of capture parameter is automatic.
integer
Time in minutes till when you can manually capture payments in the authorized state.
  • Must be equal to or greater than the automatic_expiry_period value.
  • Default value 7200 minutes.
  • Maximum value 7200 minutes.
  • Payments in the authorized state after the manual_expiry_period are auto-refunded.
string
required
Refund speed for payments that were not captured (automatically or manually). Possible values:
  • optimum: We try to process the refund instantly. We charge a small fee for this. If it is not possible to process an instant refund, we will process a normal refund in 5-7 working days. Learn more about instant refunds.
  • normal: The refund is processed in 5-7 working days.

    If no value is passed, the refund is processed using the default speed set on the Dashboard.
object
required
Details of the payment.
integer
The amount for which the order was created in currency subunits. For example, for an amount of ₹295.00, enter 29500. The same amount will be used for the payment creation. For the partial payment scenario, we will use the amount specified in the payment request object in case.
string
required
Email address of the customer.
integer
required
Contact number of the customer.
string
required
Name of the payment method (example, netbanking, cards and upi).
object
required
Details of the payment.
integer
required
Details associated with the card.
string
required
Expiry month for the card in MM format.
string
required
Name of the cardholder.
string
required
Expiry year for the card in YY format.
integer
required
CVV printed on the back of the card.
string
required
The customer’s IP address.
string
Referrer header passed by the client’s browser.
string
required
The User-Agent header of the user’s browser. The default value will be passed by Razorpay if not provided by you.
object
required
Details of the authentication method used for the payment.
string
required
Specifies the channel through which authentication is performed. In this example, it’s set to browser.
object
required
Information regarding the customer’s browser. This parameter need not be passed when authentication_channel=app.
boolean
required
Indicates whether the customer’s browser supports Java. Obtained from the navigator HTML DOM object.
boolean
required
Indicates whether the customer’s browser can execute JavaScript.Obtained from the navigator HTML DOM object.
integer
required
Time difference between UTC time and the cardholder’s browser local time. Obtained from the getTimezoneOffset() method applied to the Date object.
integer
required
Obtained from the payer’s browser using the screen.colorDepth HTML DOM property.
integer
required
Total width of the payer’s screen in pixels. Obtained from the screen.width HTML DOM property.
integer
required
Obtained from the navigator HTML DOM object.
Descriptions for the response parameters are present in the Response parameter table.
Watch Out!If you are a TPV business accepting UPI payments, you must pass method=upi in two places in this request:
  1. At the order level (top-level method field, alongside amount and currency).
  2. Inside the payment object (payment.method).
Passing method=upi only inside the payment object is not sufficient. Omitting it from the order level causes an invalid bank code error for long-tail banks. Refer to the TPV S2S UPI Intent Integration guide for details.
The following API will create a payment with UPI as the payment method:

Request Parameters

integer
required
The amount for which the order was created in currency subunits. For example, for an amount of ₹295.00, enter 29500. The same amount will be used for the payment creation. For the partial payment scenario, we will use the amount specified in the payment request object in case.
string
required
The currency in which the transaction should be made. See the list of supported currencies. Length must be of 3 characters.
string
The payment method for the order. Possible values:
  • netbanking
  • upi
  • card
Watch Out!If you are a TPV business accepting UPI payments, this field is mandatory. Pass method=upi here in addition to payment.method. Omitting method from the order level causes an invalid bank code error for long-tail banks, even when payment.method is correctly set.
string
Receipt number that corresponds to this order. Can have a maximum length of 40 characters and has to be unique.
boolean
Indicates whether the customer can make a partial payment. Possible values:
  • true: The customer can make partial payments.
  • false (default): The customer cannot make partial payments.
integer
Minimum amount that must be paid by the customer as the first partial payment. For example, if an amount of ₹7,000 is to be received from the customer in two installments of #1 - ₹5,000, #2 - ₹2,000, then you can set this value as 500000. This parameter should be passed only if partial_payment is true.
string
Unique identifier of the customer.
object
Details regarding the transfer.
string
The recipient account ID for fund transfer.
string
The amount of the transfer.
string
required
The currency in which the transaction should be made. See the list of supported currencies. Length must be of 3 characters.
object
Key-value pair that can be used to store additional information about the entity. Maximum 15 key-value pairs, 256 characters (maximum) each. For example, "note_key": "Beam me up Scotty".
string
Notes associated with the linked account.
boolean
required
Indicates whether the account settlement for transfer is on hold. Possible values:
  • true: Puts the settlement on hold.
  • false: Releases the settlement.
string
required
Timestamp until which the transfer amount is on hold.
object
Details of the bank account that the customer provides at the time of registration.
string
Account number of the customers bank account.
string
The name associated with the bank account.
string
The IFSC code of the bank.
array
Payment capture settings for the payment. The options sent here override the account level auto-capture settings configured using the Dashboard.
string
required
Option to automatically capture payment. Possible values:
  • automatic: Payments are auto-captured according to the configurations specified in the capture_options array.
  • manual: You have to manually capture payments using our Capture API or from the Dashboard.
array
Use this array to determine the expiry period for automatic and manual capture of payments and the refund speed in the case of non-capture.
integer
Time in minutes till when payments in the authorized state should be auto-captured. Minimum value 12 minutes. This parameter is mandatory only if the value of capture parameter is automatic.
integer
Time in minutes till when you can manually capture payments in the authorized state.
  • Must be equal to or greater than the automatic_expiry_period value.
  • Default value 7200 minutes.
  • Maximum value 7200 minutes.
  • Payments in the authorized state after the manual_expiry_period are auto-refunded.
string
required
Refund speed for payments that were not captured (automatically or manually). Possible values:
  • optimum: We try to process the refund instantly. We charge a small fee for this. If it is not possible to process an instant refund, we will process a normal refund in 5-7 working days. Learn more about instant refunds.
  • normal: The refund is processed in 5-7 working days.

    If no value is passed, the refund is processed using the default speed set on the Dashboard.
object
required
Details of the payment.
integer
The amount for which the order was created in currency subunits. For example, for an amount of ₹299. The same amount will be used for the payment creation. For the partial payment scenario, we will use the amount specified in the payment request object in case.
string
required
Email address of the customer. The maximum length supported is 40 characters.
integer
required
Phone number of the customer. The maximum length supported is 15 characters, inclusive of country code.
string
required
The customer’s IP address.
string
required
Name of the payment method (example, netbanking, cards and upi).
string
required
Description of the payment.
string
Referrer header passed by the client’s browser.
object
required
Details of the UPI payment received. Only applicable if method is upi.
string
The type of UPI flow. Possible value intent.
string
The customer’s VPA (Virtual Payment Address) or UPI id used to make the payment. For example, gauravkumar@exampleupi. Required when flow is collect.
string
The User-Agent header of the user’s browser. The default value will be passed by Razorpay if not provided by you.
Descriptions for the response parameters are present in the Response parameter table.

Response Parameters

If the payment request is valid, the response contains the following fields.
string
Receipt number that corresponds to this order. Can have a maximum length of 40 characters and has to be unique.
string
Status of the order. Possible values:
  • attempted: An order moves from created to attempted state when a payment is first attempted on it. It remains in the attempted state till one payment associated with that order is captured.
  • created: When you create an order it is in the created state. It stays in this state till a payment is attempted on it.
  • paid: After the successful capture of the payment, the order moves to the paid state. No further payment requests are permitted once the order moves to the paid state. The order stays in the paid state even if the payment associated with the order is refunded.
string
The unique identifier of the order.
integer
The amount for which the order was created, in currency subunits. For example, for an amount of ₹295.00, enter 29500.
integer
Indicates the Unix timestamp when this order was created.
integer
Indicates the amount paid for the order.
integer
Indicates the amount due for the order.
string
The currency in which the transaction was made. See the list of supported currencies. Length must be of 3 characters.
string
The unique identifier of the created offer.
string
The number of payment attempts, successful and failed, that have been made against this order.
string
Details regarding the transfer.
object
Key-value pair that can be used to store additional information about the entity. Maximum 15 key-value pairs, 256 characters (maximum) each.
array
Details regarding the payment.
string
Unique identifier of the payment.
array
A list of action objects available to you to continue the payment process. Present when the payment requires further processing.
string
An indication of the next step available to you to continue the payment process. Possible values:
  • otp_generate: Use this URL to allow the customer to generate OTP and complete the payment on your webpage.
  • redirect: Use this URL to redirect the customer to submit the OTP on the bank page.
string
URL endpoint where Razorpay will submit the final payment status.
Watch Out!After completing the initial step for your preferred payment method mentioned above, follow these common steps given below, applicable for all payment methods.
Watch Out!The steps given below are common for all payment methods.
Once a customer completes the payment, a POST request is made to the callback_url provided in the payment request. The data contained in this request will depend on whether the payment was a success or a failure.

Success Callback

If the payment made by the customer is successful, the following fields are sent:
  • razorpay_payment_id
  • razorpay_order_id
  • razorpay_signature
Callback Example

Failure Callback

If the payment has failed, the callback will contain details of the error. Refer to Errors for details.Given below is a sample error code you will receive when the order fails.
Order Create Failure Example
Given below is a sample error code you will receive when the payment fails.
Watch Out!You can use the order id present in the metadata for additional payment attempts on the order without creating a new one.
Payment Create Failure Example
The following error occurs when the order was processed, payment was created in Razorpay but failed at gateway level.
Gateway Processing Error Example
Use the following sample code example to make a retry request using Order id and Receipt in the request.
Signature verification is a mandatory step to ensure that the callback is sent by Razorpay. The razorpay_signature contained in the callback can be regenerated by your system and verified as follows.Create a string to be hashed using the razorpay_payment_id contained in the callback and the Order ID generated in the first step, separated by a |. Hash this string using SHA256 and your API Secret.

Generate Signature on your Server

Use Payments Rainy Day kit to overcome payments exceptions such as:
Handy TipsOn the Razorpay Dashboard, ensure that the payment status is captured. Refer to the payment capture settings page to know how to capture payments automatically.
To verify the payment status from the Razorpay Dashboard:
  1. Log in to the Razorpay Dashboard and navigate to Transactions → Payments.
  2. Check if a Payment Id has been generated and note the status. In case of a successful payment, the status is marked as Captured.
Payment details on Dashboard

Next Steps

Proceed to testing your Single Integration API integration.
Last modified on November 20, 2026